=== debian/changelog ===
biboumi (9.0-5build1) noble; urgency=high

  * No change rebuild against libudns0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:57:56 +0200

biboumi (9.0-5) unstable; urgency=medium

  * add patch cherry-picked upstream
    to not use ':' as a namespace separator with expat;
    closes: bug#1006333, thanks to Slavko and Diane Trout
  * unfuzz patches
  * update copyright info:
    + drop superfluous secondary source URI
    + update coverage
  * update git-buildpackage config:
    + use DEP-14 branch names debian/latest upstream/latest
      (not master upstream)
    + add usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 13 Mar 2022 10:17:55 +0100

biboumi (9.0-4) unstable; urgency=medium

  * explicitly disable watchdog,
    to silence systemd syntax warning;
    closes: bug#1005108, thanks to Christoph Egger
  * update copyright info:
    + use Reference field (not License-Reference)
  * set Rules-Requires-Root: no

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 09 Feb 2022 14:12:32 +0100

biboumi (9.0-3) unstable; urgency=medium

  * simplify copyright-check
  * stop build-depend explicitly on gcc,
    and build-depend on native python3-sphinx,
    both needed to make package cross-buildable;
    closes: Bug#987572, thanks to Nilesh Patra
  * declare compliance with Debian Policy 4.6.0

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Aug 2021 15:44:29 +0200

biboumi (9.0-2) unstable; urgency=medium

  * Set default database and log level
  * Change owner of data directory in postinst
  * Migrate to dh from CDBS
  * Add versionmangle for RC releases

 -- Michel Le Bihan <michel@lebihan.pl>  Mon, 18 Jan 2021 12:10:02 +0100

biboumi (9.0-1) unstable; urgency=medium

  [ upstream ]
  * New release(s) (Closes: Bug#957037 and Bug#976356).

 -- Michel Le Bihan <michel@lebihan.pl>  Sat, 19 Dec 2020 15:43:03 +0200
