=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- -DSERVICE_USER=_biboumi -DSERVICE_GROUP=_biboumi -DWATCHDOG_SEC=0

execute_after_dh_auto_install:
	mkdir -p debian/biboumi/lib
	mv debian/biboumi/usr/lib/systemd debian/biboumi/lib
	rmdir debian/biboumi/usr/lib
	cp conf/biboumi.cfg debian/biboumi/etc/biboumi
	sed -i -e 's/db_name=/db_name=\/var\/lib\/biboumi\/biboumi.sqlite/' \
		debian/biboumi/etc/biboumi/biboumi.cfg
	echo log_level=1 >> debian/biboumi/etc/biboumi/biboumi.cfg

%:
	dh $@
