## biboumi 9.0%2B20231006

=== debian/changelog ===
biboumi (9.0+20231006-2) unstable; urgency=medium

  * acknowledge and revive 9.0-5.1;
    closes: bug#1073626,
    thanks to Chris Hofstaedtler and Michael Biebl

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Oct 2024 21:05:24 +0100

biboumi (9.0+20231006-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot
    Highlights:
    + Always send direct messages to the user’s bare JID
    + Do not mark message to bare JID private/no-copy
    + sasl: Use the nick from the presence
      if the ad-hoc one is not set
    + Use recipient-unavailable
      when we are not connected to the IRC server
    + Catch all botan exception when sending data, not just TLS
    + Follow-up of the previous on: also catch that on recv events
    + Do not use ':' as a namespace separator with expat
    + utils/sha1.cpp: add missing <cstdint> include
    + Replace inexistant lightmagenta CSS colour with hotpink

  [ Jonas Smedegaard ]
  * update source URIs for new home at codeberg.org
  * update watch file:
    + track git commits (not release tags);
    + improve usage comments
  * declare compliance with Debian Policy 4.7.0
  * build-depend on libidn-dev (not libidn11-dev);
    closes: bug#1086094, thanks to Simon Josefsson
  * drop patch cherry-picked upstream, now obsolete

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 26 Oct 2024 22:04:55 +0200

biboumi (9.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install systemd units into /usr. (Closes: #1073626)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 11 Jul 2024 14:29:02 +0200
