## biboumi 9.0%2B20250730

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=9.0+%cd,\
dversionmangle=auto \
https://codeberg.org/poezio/biboumi.git \
HEAD
