## biboumi 9.0+20231006

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
  libexpat1-dev,
- libidn11-dev,
+ libidn-dev,
  libsystemd-dev,
  libudns-dev,
  libbotan-2-dev,
@@ -13,15 +13,14 @@
  catch,
  uuid-dev,
  python3-sphinx:native,
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>,
  Michel Le Bihan <michel@lebihan.pl>
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/biboumi.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/biboumi
-Homepage: https://lab.louiz.org/louiz/biboumi/
+Homepage: https://codeberg.org/poezio/biboumi
 Rules-Requires-Root: no
 
 Package: biboumi
