=== debian/changelog ===
biboumi (9.0+20241124-3) unstable; urgency=medium

  * Re-enable TLS
  * Adopt package back into VoIP Team (Closes: #1100511)

 -- Bastian Germann <bage@debian.org>  Wed, 23 Jul 2025 21:32:16 +0200

biboumi (9.0+20241124-2) unstable; urgency=medium

  * QA upload
  * Disable TLS (Closes: #1109758)

 -- Bastian Germann <bage@debian.org>  Wed, 23 Jul 2025 16:44:01 +0200

biboumi (9.0+20241124-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.7.2
  * orphan package

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Mar 2025 18:33:11 +0100
