=== debian/control ===
--- 
+++ 
@@ -14,10 +14,8 @@
  uuid-dev,
  python3-sphinx:native,
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
-Uploaders: Jonas Smedegaard <dr@jones.dk>,
- Vasudev Kamath <vasudev@copyninja.info>,
- Michel Le Bihan <michel@lebihan.pl>
-Standards-Version: 4.7.0
+Uploaders: Bastian Germann <bage@debian.org>
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/biboumi.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/biboumi
 Homepage: https://codeberg.org/poezio/biboumi
