=== debian/changelog ===
biboumi (9.0+20250730-2) unstable; urgency=medium

  * Prevent auto-start (config is incomplete)

 -- Bastian Germann <bage@debian.org>  Sun, 10 Aug 2025 12:28:00 +0200

biboumi (9.0+20250730-1) experimental; urgency=medium

  * development snapshot
  * Build with botan3 (Closes: #1109758)

 -- Bastian Germann <bage@debian.org>  Mon, 04 Aug 2025 15:15:56 +0200
