=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libidn-dev,
  libsystemd-dev,
  libudns-dev,
- libbotan-2-dev,
+ libbotan-3-dev,
  libsqlite3-dev,
  libpq-dev,
  cmake,
