=== debian/rules ===
--- 
+++ 
@@ -9,5 +9,8 @@
 		debian/biboumi/etc/biboumi/biboumi.cfg
 	echo log_level=1 >> debian/biboumi/etc/biboumi/biboumi.cfg
 
+override_dh_installsystemd:
+	dh_installsystemd --no-start --no-enable
+
 %:
 	dh $@
